#!/usr/bin/python3
# require py-hidapi

import sys
import os.path
import hid
import argparse
from time import sleep
import random

#debug=True
debug=False
tuloste=[]

class ATENUsbSwitch(object):
    def __init__(self, vendor_id=1367, product_id=9221):
        self.vendor_id = vendor_id
        self.product_id = product_id
        self.device = None
        i=1
        self.tuloste=""
        while os.path.isfile(str(i)+"-tuloste.txt"):
            i+=1
        if debug:
            self.ffile=open(str(i)+"-tuloste.txt","w")
            print("OPEN FILENAME=",str(i)+"-tuloste.txt")
    def __del__(self):
        self._close()

    def _open(self):
        self.device = hid.device()
        for dev in hid.enumerate(self.vendor_id, self.product_id):
            if debug:
                print(dev)
            if dev["interface_number"] == 1:
                self.device.open_path(dev["path"])

    def _close(self):
        if self.device:
            self.device.close()
        #self.file.close()


    def is_active(self):
        #global tuloste
        #tuloste=[]
        try:
            ret=False
            self._open()
            #while True:

            self.tuloste=self.device.read(50)
            if debug:
                print("readed")
                print("tuloste=",self.tuloste)
            ret=False
            self._close()
            if debug:
                self.ffile.write("t="+str(self.tuloste)+"\n")
            return ret
        except ValueError as e:
            if debug:
                print("ValueError:",e)
            return True
        except:
            if debug:
                print("tuloste=",self.tuloste)
                self.ffile.write("tuloste="+str(self.tuloste)+"\n")
            status = -1 #self.device.read(4)

            if debug:
                print(status)
        #else:
        return False
            #return (status[1] & 0x01)

    def is_locked(self):
        try:
            self._open()
            status = self.device.read(4)
            self._close()
        except ValueError as e:
            return False
        else:
            return (status[1] & 0x02)

    def switch(self, wait=True):
        rnd=-2
        a=2
        b=17
        b=[2]
        #b=20
        #b=3
        #while b<256:
        #self.tuloste=[]
        s="rnd"
        first=True
        buff=[]
        while b[0]<256:
            #b+=1
            #print("self.tuloste=",self.tuloste)
            if buff==[]:
                #if self.tuloste=[1, 18, 192, 1]:
                if self.tuloste==[1, 18, 66, 1]:
                    buff=[[2, 3],[2, 5],[2, 5],[2, 18],[2, 23]]
                elif self.tuloste==[1,18,64,1]:
                    buff=[[2,18],[2,23]]
                elif self.tuloste==[1,33,192,2]:
                    buff=[[2,103],[2,18],[2,5],[2,23]]
                elif self.tuloste==[1,33,64,2]:
                    buff=[[2,19],[2,23]]
                elif self.tuloste==[1,18,192,1]:# and (not first):
                    b=[2,23]
                    print("TULI LOPETUSARVOONSA:",b)
                elif self.tuloste[-1:]==[1]:
                    rnd=-1
                    print("VIIMEINEN SOLU ON 1, OSAATKO PÄÄTTÄÄ OHJELMAN SUORITUKSEN ?")
                    b=[]
                else:
                    b=[]
            else:
                b=buff[0]
                buff=buff[1:]
            first=False
            if b==[]:
                if rnd<=0:
                    if self.tuloste=="":
                        print("Oikeudet eivät taida riittää tämän ajamiseen!?")
                        print("Kokeile sudolla!")
                        exit(2)
                    print("self.tuloste=",self.tuloste)
                    s=input("Anna seuraava numeroarray ( 2 19-lopettaa kyselyn ja asettaa usb:n aktiiviseksi):")
                    if s[:3]=="rnd":
                        if len(s)>3:
                            rnd=int(s[3:].strip())
                        else:
                            rnd=255
                        s="rnd"
                        #rnd=255

                if s=="rnd":
                    b=[2,random.randint(0,255)]
                    rnd-=1
                    print("B=",b)
                else:
                    a=s.split(" ")
                    for v in a:
                        s=v.strip()
                        if s!="":
                            b.append(int(s))
            if debug:
                print("rnd=",rnd)
                print("b=",b)
            self._open()
            #self.device.write([0x02, 0x11])
            #self.device.write([0x02,b])
            self.device.write(b)
            self._close()
            #self.fflile.writeln(str(b))
            wait_for_active = wait
            #while wait_for_active:
            if wait_for_active:
                sleep(3)
                if debug:
                    self.ffile.write(str(b)+"\n")
                try:
                    if self.is_active():
                        wait_for_active = False
                        return True
                        #break
                except OSError as e:
                    pass
                    #continue

    def lock(self):
        self._open()
        self.device.write([0x02, 0x11])
        self._close()

    def unlock(self):
        self._open()
        self.device.write([0x02, 0x20])
        self._close()

    def keep_locked(self):
        self._open()
        self.lock()
        while True:
            sleep(4)
            self.device.write([0x02, 0x40])
        self._close()


if __name__ == "__main__":
    usbsw = ATENUsbSwitch()
    argp = argparse.ArgumentParser(description="ATEN USB Switch CLI")
    argp.add_argument("-a", "--is-active", dest="do_check", action="store_true", help="return 0 if we are the active host")
    argp.add_argument("-s", "--switch", dest="do_switch", action="store_true", help="switch ourselves to be the active host")
    argp.add_argument("--carp", dest="carp_mode", action="store", choices=["MASTER", "BACKUP"],
            help="cleam switch based on CARP VIP status")
    argp.add_argument("-v", "--verbose", dest="be_verbose", action="store_true", help="verbose console messages")
    args = argp.parse_args()

    if args.carp_mode:
        args.do_switch = True if args.carp_mode == "MASTER" else False
        args.do_check = True if args.carp_mode == "BACKUP" else False

    if args.do_check and args.do_switch and args.be_verbose:
        print("WARNING: both --is-active and --switch provided, ignoring --switch!", file=sys.stderr)

    if args.do_check:
        if usbsw.is_active():
            if args.be_verbose:
                print("This host is active.")
            usbsw.ffile.close()
            sys.exit(0)
        else:
            if args.be_verbose:
                print("Another host is active.")
            try:
                #print(usbsw.ffile)
                usbsw.ffile.close()
            except:
                pass
            sys.exit(1)
    elif args.do_switch:
        if not usbsw.is_active():
            if args.be_verbose:
                print("Switching this host to active...")
            usbsw.switch()
        if usbsw.is_active():
            if args.be_verbose:
                print("This host is now active.")
            if debug:
                usbsw.ffile.close()
            sys.exit(0)
        else:
            if args.be_verbose:
                print("ERROR: Failed to switch!", file=sys.stderr)
            usbsw.ffile.close()
            sys.exit(1)
    else:
        argp.print_help()
        #if isset(usbsw.ffile:
        #    usbsw.ffile.close()
        sys.exit(2)
